Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParserXerces.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParserXerces.h	(revision 2227)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParserXerces.h	(revision 2575)
@@ -8,7 +8,14 @@
 #include "Mesh.h"
 #include "BoundingBoxConverter.h"
+
+#ifdef __WINDOWS__
 #include <hash_map>
-
+#else
+#include <map>
+#endif
+
+#ifdef PERFTIMER  
 #include "Timer/PerfTimer.h"
+#endif
 
 namespace GtpVisibilityPreprocessor {
@@ -54,6 +61,9 @@
 
 
+#ifdef __WINDOWS__
 typedef stdext::hash_map<int, Intersectable *> pvs_hash;
-
+#else
+typedef std::map<int, Intersectable *> pvs_hash;
+#endif  
 
 class ViewCellsParseHandlers: public HandlerBase
@@ -158,8 +168,10 @@
   int nObjects;
   
+#ifdef PERFTIMER  
   PerfTimer mBoxTimer;
   PerfTimer mPvsTimer;
   PerfTimer mObjectTimer;
-
+#endif
+  
   pvs_hash mHashPvs;
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Rectangle3.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Rectangle3.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Rectangle3.h	(revision 2575)
@@ -51,5 +51,5 @@
       v += CrossProd(mVertices[i], mVertices[i+1]);
     
-    return 0.5f*abs(DotProd(GetNormal(), v));
+    return 0.5f * fabs(DotProd(GetNormal(), v));
   }
   
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2574)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2575)
@@ -117,5 +117,5 @@
 Timer/BenchTimer.cpp Timer/merror.cpp \
 Intersectable.cpp TraversalTree.cpp ObjectPvs.cpp ObjectsParser.cpp \
-FilterBasedDistribution.cpp DifferenceSampling.cpp
+FilterBasedDistribution.cpp DifferenceSampling.cpp HavranRayCaster.cpp
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 2543)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.cpp	(revision 2575)
@@ -409,4 +409,5 @@
 	double sortTime, evalTime, nodeTime, splitTime, subdTime, planeTime, collectTime, viewCellsTime;
 
+#ifdef PERFTIMER  	
 	sortTime = mBvHierarchy->mSortTimer.TotalTime();
 	evalTime = mBvHierarchy->mEvalTimer.TotalTime();
@@ -416,5 +417,6 @@
 	planeTime = mBvHierarchy->mPlaneTimer.TotalTime();
 	collectTime = mBvHierarchy->mCollectTimer.TotalTime();
-
+#endif // #ifdef PERFTIMER 
+	
 	cout << "bvh times"
 		 << " sort : " << sortTime
@@ -437,4 +439,5 @@
 		 << endl;
 
+#ifdef PERFTIMER  
 	sortTime = mVspTree->mSortTimer.TotalTime();
 	evalTime = mVspTree->mEvalTimer.TotalTime();
@@ -444,5 +447,6 @@
 	planeTime = mVspTree->mPlaneTimer.TotalTime();
 	viewCellsTime = mVspTree->mViewCellsTimer.TotalTime();
-
+#endif
+	
 	cout << "vsp times"
 		 << " sort : " << sortTime
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2543)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 2575)
@@ -147,5 +147,7 @@
 		EndObjectSpaceHierarchy();
 		Debug << "object space hierarchy parsed" << endl;
+#ifdef PERFTIMER  
 		mObjectTimer.Exit();
+#endif
 	}
 	// finished paring, create view cells manager
@@ -154,8 +156,9 @@
 		CreateViewCellsManager();
 
+#ifdef PERFTIMER  
 		Debug << "pvs time: " << mPvsTimer.TotalTime() << endl;
 		Debug << "object time: " << mObjectTimer.TotalTime() << endl;
 		Debug << "box time: " << mBoxTimer.TotalTime() << endl;
-
+#endif
 	}
 	else if (element == "Interior")
@@ -298,6 +301,7 @@
 	const long startTime = GetTime();
 	
+#ifdef PERFTIMER  
 	mBoxTimer.Entry();
-
+#endif
 	if (mBoundingBoxConverter)
 	{
@@ -320,5 +324,7 @@
 		  << TimeDiff(startTime, GetTime()) * 1e-6 << " secs" << endl;
 
+#ifdef PERFTIMER  
 	mBoxTimer.Exit();
+#endif
 }
 
@@ -481,5 +487,7 @@
 
 		mCurrentState = PARSE_OBJECTSPACE_HIERARCHY;
+#ifdef PERFTIMER  
 		mObjectTimer.Entry();
+#endif
 		StartObjectSpaceHierarchy(attributes);
 	}
@@ -539,6 +547,7 @@
 	}
 
+#ifdef PERFTIMER  
 	mPvsTimer.Entry();
-
+#endif
 	Intersectable::NewMail();
 
@@ -582,5 +591,7 @@
 	}
 	
+#ifdef PERFTIMER  
 	mPvsTimer.Exit();
+#endif
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/PlyParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/PlyParser.cpp	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/PlyParser.cpp	(revision 2575)
@@ -1,6 +1,6 @@
 #include <iostream>
-#include <ply.h>
-#include <stdio.h>
-
+#include <cstdio>
+
+#include "ply.h"
 #include "PlyParser.h"
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/AxisAlignedBox3.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/AxisAlignedBox3.cpp	(revision 2332)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/AxisAlignedBox3.cpp	(revision 2575)
@@ -1,5 +1,3 @@
 
-// GOLEM library
-#include <assert.h>
 #include <iostream>
 #include "AxisAlignedBox3.h"
@@ -10,4 +8,8 @@
 #include "Triangle3.h"
 #include "VssRay.h"
+
+
+
+#include <cassert>
 
 
@@ -210,6 +212,6 @@
 int
 AxisAlignedBox3::ComputeMinMaxT(const Ray &ray,
-								float *tmin,
-								float *tmax) const
+				float *tmin,
+				float *tmax) const
 {
   float minx, maxx, miny, maxy, minz, maxz;
@@ -302,6 +304,6 @@
 int
 AxisAlignedBox3::ComputeMinMaxT(const Ray &ray,
-								float *tmin,
-								float *tmax) const
+				float *tmin,
+				float *tmax) const
 {
   const float dirEps = 1e-8f;
@@ -398,5 +400,5 @@
 // the bounding box and 0 if it does not.
 int AxisAlignedBox3::ComputeMinMaxT(const Ray &ray, float *tmin, float *tmax,
-									EFaces &entryFace, EFaces &exitFace) const
+				    EFaces &entryFace, EFaces &exitFace) const
 {
   float minx, maxx, miny, maxy, minz, maxz;
@@ -1840,9 +1842,8 @@
 int
 AxisAlignedBox3::ComputeMinMaxT(const Vector3 &origin,
-								const Vector3 &direction,
-								float *tmin,
-								float *tmax) const
-{
-
+				const Vector3 &direction,
+				float *tmin,
+				float *tmax) const
+{
   register float minx, maxx;
 
@@ -2235,7 +2236,53 @@
 
 
+void AxisAlignedBox3::EnlargeToMinSize()
+{
+  const float epsMin = 1e-7;
+  const float epsAdd = 1e-6;
+  const float epsMul = 1.000005;
+  float dir = mMax.x - mMin.x;
+  assert(dir >= 0.f);
+  if (dir < epsMin) {
+    if (mMax.x > 0) {
+      mMax.x *= epsMul;
+      mMax.x += epsAdd;
+    }
+    else {
+      mMin.x *= epsMul;
+      mMin.x -= epsAdd;
+    }
+    assert(mMin.x < mMax.x);
+  }
+  dir = mMax.y - mMin.y;
+  assert(dir >= 0.f);
+  if (dir < epsMin) {
+    if (mMax.y > 0) {
+      mMax.y *= epsMul;
+      mMax.y += epsAdd;
+    }
+    else {
+      mMin.y *= epsMul;
+      mMin.y -= epsAdd;
+    }
+    assert(mMin.y < mMax.y);
+  }
+  dir = mMax.z - mMin.z;
+  assert(dir >= 0.f);
+  if (dir < epsMin) {
+    if (mMax.z > 0) {
+      mMax.z *= epsMul;
+      mMax.z += epsAdd;
+    }
+    else {
+      mMin.z *= epsMul;
+      mMin.z -= epsAdd;
+    }
+    assert(mMin.z < mMax.z);
+  }
+}
+
 void AxisAlignedBox3::SetMin(const Vector3 &v) 
 {
-	mMin = v;
+  mMin = v;
 }
 
@@ -2243,5 +2290,5 @@
 void AxisAlignedBox3::SetMax(const Vector3 &v) 
 {
-	mMax = v;
+  mMax = v;
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Camera.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Camera.cpp	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Camera.cpp	(revision 2575)
@@ -5,11 +5,20 @@
 #include <IL/ilu.h>
 #include <IL/ilut.h>
+#include <cassert>
 
 #include "Camera.h"
 #include "Ray.h"
+#include "SimpleRay.h"
 #include "KdTree.h"
 #include "Mesh.h"
 #include "Exporter.h"
 #include "SceneGraph.h"
+#include "Preprocessor.h"
+#include "RayCaster.h"
+
+#ifdef USE_HAVRAN_RAYCASTER 
+//#include "timer.h"
+#include "raypack.h"
+#endif
 
 using namespace std;
@@ -36,7 +45,7 @@
 bool
 Camera::SnapImage(string filename,
-				  KdTree *tree,
-				  SceneGraph *sceneGraph
-				  )
+		  KdTree *tree,
+		  SceneGraph *sceneGraph
+		 )
 {
   int x;
@@ -167,3 +176,207 @@
 }
 
-}
+
+void
+Camera::SetupRay(SimpleRay &ray, const int x, const int y)
+{
+  Vector3 xv = mRight*((x - mWidth/2)/(float)mWidth);
+  Vector3 yv = mUp*((y - mHeight/2)/(float)mHeight);
+  Vector3 target = xv + yv + mDirection;
+  Vector3 dir = target - mPosition;
+  dir.Normalize();
+  
+  ray.Set(mPosition, dir, 0,
+	  1.0f, ~(SimpleRay::F_BIDIRECTIONAL));
+}
+
+bool
+Camera::SnapImage(string filename,
+		  RayCaster *raycaster,
+		  AxisAlignedBox3 &bbox,
+		  SceneGraph *sceneGraph
+		  )
+{
+  int x;
+  int y;
+
+  bool exportRays = false;
+
+  
+  InitDevIl();
+  int components = 4;
+  float *buffer = new float[components*mWidth*mHeight];
+  assert(buffer);
+  float *pbuffer = buffer;
+  //  - components*mWidth;
+  
+  vector<Ray *> rays;
+
+  long t1 = GetTime();
+
+  SimpleRay ray;
+  VssRayContainer vssRays;
+
+  //CTimer timer;
+  //timer.Start();
+  
+  for (y = 0; y < mHeight; y++) {
+    cout<<"+";
+    for (x = 0; x < mWidth; x++) {
+      SetupRay(ray, mWidth - (x + 1), mHeight - (y + 1));
+
+      bool debug = true;
+      //	  (y == mHeight/2) && (x== mWidth/3);
+      //	  MeshDebug = debug;
+      
+
+      int res = raycaster->CastRay(ray,
+				   vssRays,
+				   bbox,
+				   false, // castDoubleRay,
+				   false); // pruneInvalidRays
+      
+      if (res) {
+	Vector3 normal = raycaster->intersect.mNormal;
+	float v =
+	  ray.mDirection.x * normal.x +
+	  ray.mDirection.y * normal.y +
+	  ray.mDirection.z * normal.z;
+	v *= 1.0f;
+	pbuffer[0] = v;
+	pbuffer[1] = v;
+	pbuffer[2] = v;
+	pbuffer[3] = 1.0f;		  
+      }
+      else {
+	pbuffer[0] = 0.0;
+	pbuffer[1] = 0.0;
+	pbuffer[2] = 0.0;
+	pbuffer[3] = 1.0f;
+      }
+      pbuffer+=components;
+      
+      if (debug) {
+	Ray *nray = new Ray(ray.mOrigin, ray.mDirection,
+			    Ray::LOCAL_RAY);
+	rays.push_back(nray);
+      }
+    }
+    //    pbuffer-=2*components*mWidth;
+  } // for y
+
+  //timer.Stop();
+  
+  long t2 = GetTime();
+  cout<<"\n#RAY_CAST_TIME = ";
+  cout << TimeDiff(t1, t2)<<" [mikrosec]\n";  
+  
+  cout<<"Saving image"<<endl;
+  
+  ilRegisterType(IL_FLOAT);
+  ilTexImage(mWidth, mHeight, 1, 4, IL_RGBA, IL_FLOAT, buffer);
+  ilSaveImage((char *const)filename.c_str());
+  delete buffer;
+
+  cout<<"done."<<endl<<flush;
+    
+  return true;
+}
+
+bool
+Camera::SnapImagePacket(string filename,
+			RayCaster *raycaster,
+			AxisAlignedBox3 &bbox,
+			SceneGraph *sceneGraph
+			)
+{
+#ifdef USE_HAVRAN_RAYCASTER 
+  
+  int x;
+  int y;
+
+  bool exportRays = false;
+
+  
+  InitDevIl();
+  int components = 4;
+  float *buffer = new float[components*mWidth*mHeight];
+  assert(buffer);
+  float *pbuffer = buffer;
+  //  - components*mWidth;
+  
+  vector<Ray *> rays;
+
+  long t1 = GetTime();
+
+  SimpleRay ray;
+  VssRayContainer vssRays;
+
+  //CTimer timer;
+  //timer.Start();
+
+  RayPacket2x2 rp;
+  for (y = 0; y < mHeight-1; y+=2) {
+    float *pppbuffer = pbuffer;
+    cout<<"+";
+    for (x = 0; x < mWidth-1; x+=2) {
+      int i = 0;
+      for (int yi = 0; yi < 2; yi++) {
+	for (int xi = 0; xi < 2; xi++) {
+	  SetupRay(ray, mWidth - (x+xi + 1), mHeight - (y+yi + 1));
+	  rp.SetLoc(i, ray.mOrigin);
+	  rp.SetDir(i, ray.mDirection);
+	  i++;
+	} // for xi
+      } // for yi      
+
+      raycaster->CastRaysPacket2x2(rp, false, false);
+
+      i = 0;
+      float *ppbuffer = pbuffer;
+      for (int yi = 0; yi < 2; yi++) {
+	for (int xi = 0; xi < 2; xi++) {
+	  Intersectable* res = rp.GetObject(i);
+	  if (res) {
+	    pbuffer[0] = 1.0f;
+	    pbuffer[1] = 1.0f;
+	    pbuffer[2] = 1.0f;
+	    pbuffer[3] = 1.0f;		  
+	  }
+	  else {
+	    pbuffer[0] = 0.0;
+	    pbuffer[1] = 0.0;
+	    pbuffer[2] = 0.0;
+	    pbuffer[3] = 1.0f;
+	  }
+	  i++;
+	  ppbuffer += components;
+	} // xi
+	ppbuffer += components * (mWidth-2);
+      } // yi
+
+      pbuffer = ppbuffer + 2 * components;
+    } // for x
+    pbuffer = pppbuffer + mWidth * 2 * components;
+    pppbuffer = pbuffer; // for the next time;
+  } // for y
+
+  //timer.Stop();
+  
+  long t2 = GetTime();
+  cout<<"\n#RAY_CAST_TIME = ";
+  cout << TimeDiff(t1, t2)<<" [mikrosec]\n";  
+  
+  cout<<"Saving image"<<endl;
+  
+  ilRegisterType(IL_FLOAT);
+  ilTexImage(mWidth, mHeight, 1, 4, IL_RGBA, IL_FLOAT, buffer);
+  ilSaveImage((char *const)filename.c_str());
+  delete buffer;
+#endif
+  cout<<"done."<<endl<<flush;
+    
+  return true;
+}
+  
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.h	(revision 2569)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/IntersectableWrapper.h	(revision 2575)
@@ -40,4 +40,7 @@
 	
 	int CastRay(Ray &ray);
+	int CastSimpleRay(const SimpleRay &ray) { return 0;}
+        int CastSimpleRay(const SimpleRay &ray, int RayIndex) { return 0;}
+  
 	
 	bool IsConvex() const;
@@ -193,7 +196,12 @@
 
 	int CastRay(Ray &ray);
+
+	int CastSimpleRay(const SimpleRay &ray);
+        int CastSimpleRay(const SimpleRay &ray, int rayIndex);
+	
 	AxisAlignedBox3 GetBox() const;
 	int NumberOfFaces() const;
 	Vector3 GetNormal(const int idx) const;
+	Vector3 GetNormal() const { return mItem.GetNormal();}
 
 	float GetArea() const {return mItem.GetArea();}
@@ -207,12 +215,12 @@
 
 	int GetRandomSurfacePoint(const float u,
-							  const float v,
-							  Vector3 &point, Vector3 &normal);
+				  const float v,
+				  Vector3 &point, Vector3 &normal);
 
 	
 	int GetRandomVisibleSurfacePoint(Vector3 &point,
-									 Vector3 &normal,
-									 const Vector3 &viewpoint,
-									 const int maxTries);
+					 Vector3 &normal,
+					 const Vector3 &viewpoint,
+					 const int maxTries);
 
 	int GetRandomEdgePoint(Vector3 &point, Vector3 &normal);
@@ -244,5 +252,5 @@
 
 	// hack
-	ContainerIntersectable::~ContainerIntersectable() 
+	~ContainerIntersectable() 
 	{
 		delete mItem;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 2566)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.cpp	(revision 2575)
@@ -1,2 +1,3 @@
+
 #include "SamplingStrategy.h"
 #include "Ray.h"
@@ -7,15 +8,21 @@
 #include "RssTree.h"
 #include "Mutation.h"
+#include "FilterBasedDistribution.h"
+#include "DifferenceSampling.h"
+
+
+#ifdef PERFTIMER
 #include "Timer/PerfTimer.h"
-#include "DifferenceSampling.h"
-
-
+#endif
 
 namespace GtpVisibilityPreprocessor {
 
+
+#ifdef PERFTIMER
 extern PerfTimer haltonTimer;
 extern PerfTimer pvsTimer;
 extern PerfTimer viewCellCastTimer;
-
+#endif
+  
 //HaltonSequence SamplingStrategy::sHalton;
 
@@ -221,5 +228,5 @@
 																	   r[4],
 																	   r[5])
-																	   ) - origin;
+															   ) - origin;
 	
 	const float c = Magnitude(direction);
@@ -591,8 +598,9 @@
   if (1)
   {
+#ifdef PERFTIMER
 	  const float vcTime = viewCellCastTimer.TotalTime();
 	  const float pvsTime = pvsTimer.TotalTime();
 	  const float haltonTime = haltonTimer.TotalTime();
-
+	  
 	  cout << "view cell cast time: " << vcTime << " s" << endl;
 	  cout << "pvs time: " << pvsTime << " s" << endl;
@@ -602,4 +610,8 @@
 	  Debug << "pvs time: " << pvsTime << " s" << endl;
 	  Debug << "halton time: "<< haltonTime << " s" << endl;
+#else
+	  cout << "Timers not supported" << endl;
+	  Debug << "Timers for PVS,Halton,Viewcell not supported" << endl;
+#endif
   }
 }
@@ -712,8 +724,12 @@
 					if (strcmp(curr, "mutation")==0) {
 					 mDistributions.push_back(new MutationBasedDistribution(mPreprocessor));
-					}
+					} else
+					  if (strcmp(curr, "filter_based")==0) {
+						mDistributions.push_back(new FilterBasedDistribution(mPreprocessor));
+					  }
 					else if (strcmp(curr, "difference")==0) {
 					 mDistributions.push_back(new DifferenceSampling(mPreprocessor));
 					}
+	
 	
 	
